@echo off

rem   This batch file is used to compile named files.

rem   This program is called by cpile.exe, which provides the file name
rem   in parts, all in lower case.
rem   1 is full path name
rem   2 is base file name, without extension
rem   3 is the extension with the period "."

rem   by David Rife 13 November 2007
rem   Edited 18 November 2007
rem   Edited 01 September 2008

rem   File names whose extensions are .bas, .c, .cpp, .sim, and .slt
rem   can be compiled.  Batch files will be converted to COM files using
rem   bat2exe.com.

if '%3' == '' goto helper
if not exist %1 goto nofile
if "%3" == ".bas" goto link_bas
if "%3" == ".bat" goto link_bat
if "%3" == ".slt" goto link_slt
if "%3" == ".sim" goto link_sim
if "%3" == ".c" goto link_c
if "%3" == ".cpp" goto link_cpp

:helper
cls
echo.
echo This batch program is called by cpile.exe to compile programs whose
echo extensions are .slt, .sim, .bas, .bat, .c, and .cpp.
echo Batch files are converted to COM files using bat2exec.com.
echo.
echo Inputs are: full file path name, base file name, and extension with the period.
echo.
goto end

:link_slt
cs.exe %1
goto done

:link_sim
css.exe %1
goto done

:link_c
if not exist %2%3 goto nofile
tcc.exe %2.c
del  %2.obj
goto done

:link_cpp
if not exist %2%3 goto nofile
tcc.exe %2.cpp
del  %2.obj
goto done

:link_bat
if not exist %2%3 goto nofile
bat2exec.com %2.bat
goto end

:link_bas
if not exist %2%3 goto nofile
c:\qb45\BC.EXE %2/O/E/W/X;
c:\qb45\LINK.EXE %2,,null,c:\qb45\bcom45.lib;
del %2.obj
del null.map
goto done

:done
pklite %2.exe
goto end

:nofile
cls
echo.
echo  File not found.
echo.
goto end

:end

