
'   Program to convert GETALL.FON to mTelnet compatible fon file.

'   Free from David Rife 09-02-2008.

    ON ERROR GOTO TRAPPER

    F1$ = "TEMP.FON"
    F2$ = "MTEL1.FON"

    OPEN F1$ FOR INPUT AS #1
    OPEN F2$ FOR OUTPUT AS #2

    M = 0
    M1 = 200

    WHILE NOT EOF(1) AND M < M1
        LINE INPUT #1, L$
        GOSUB GETPARTS
        L1 = LEN(NAME$)
        IF L1 > 4 THEN

            NAME$ = MID$(NAME$, 1, 60)
            NUMBER$ = MID$(NUMBER$, 1, 60)
            PWORD$ = MID$(PWORD$, 1, 30)
            LDATE$ = MID$(LDATE$, 1, 8)
            USERNAME$ = MID$(USERNAME$, 1, 30)

            PRINT #2, CHR$(L1);
            PRINT #2, NAME$;

            IF L1 < 60 THEN
                FOR I = L1 + 1 TO 60
                    PRINT #2, CHR$(0);
                NEXT I
            END IF

            L2 = LEN(NUMBER$)
            PRINT #2, CHR$(L2);
            PRINT #2, NUMBER$;

            IF L2 < 60 THEN
                FOR j = L2 + 1 TO 60
                    PRINT #2, CHR$(0);
                NEXT j
            END IF

            IF LDATE$ = "00/00/00" THEN
                FOR j = 123 TO 135
                    PRINT #2, CHR$(0);
                NEXT j
            ELSE
                PRINT #2, CHR$(8);
                PRINT #2, LDATE$;
                FOR j = 132 TO 135
                    PRINT #2, CHR$(0);
                NEXT j
            END IF

            L3 = LEN(PWORD$)
            PRINT #2, CHR$(L3);
            PRINT #2, PWORD$;
            IF L3 < 30 THEN
                FOR j = L3 + 1 TO 30
                    PRINT #2, CHR$(0);
                NEXT j
            END IF

            L4 = LEN(USERNAME$)
            PRINT #2, CHR$(L4);
            PRINT #2, USERNAME$;
            IF L4 < 30 THEN
                FOR j = L4 + 1 TO 30
                    PRINT #2, CHR$(0);
                NEXT j
            END IF

            M = M + 1
        END IF

    WEND

    IF M = M1 THEN GOTO ALLDONE

    FOR j = M + 1 TO M1
        GOSUB MTBLANK
    NEXT j

ALLDONE:
    CLOSE
    PRINT F2$ + " has been created from " + F1$ + "."
    SYSTEM
    END

MTBLANK:
    FOR L = 1 TO 197
        PRINT #2, CHR$(0);
    NEXT L
    RETURN


'   This routine extracts the parts of a {COMMO} phone directory line.

GETPARTS:
    NAME$ = ""
    NUMBER$ = ""
    LDATE$ = ""
    PWORD$ = ""
    SCRIPT$ = ""
    SPEED$ = ""
    USERNAME$ = ""
    NCALLS$ = "0"
    prefix = 1

    X = INSTR(L$, "/")
    IF X > 10 THEN LDATE$ = MID$(L$, X - 2, 8)
    IF MID$(LDATE$, 6, 1) <> "/" THEN LDATE$ = "00/00/00"

    X = 0: Y = 0
    X = INSTR(L$, "{")
    Y = INSTR(L$, "}")
    IF X = 0 THEN RETURN
    IF Y < X + 1 THEN GOTO BADSOURCE

    NAME$ = MID$(L$, 1, X - 1)              ' extract name
    NAME$ = LTRIM$(NAME$)                   ' remove left spaces
    NAME$ = RTRIM$(NAME$)                   ' remove right spaces

    NUMBER$ = MID$(L$, X + 1, Y - X - 1)    ' extract number
    NUMBER$ = LTRIM$(NUMBER$)
    NUMBER$ = RTRIM$(NUMBER$)

    B$ = MID$(L$, Y + 1)
    X = INSTR(B$, "{")
    Y = INSTR(B$, "}")
    IF X = 0 THEN RETURN
    IF Y < X + 1 THEN GOTO BADSOURCE

    PWORD$ = MID$(B$, X + 1, Y - X - 1)     ' extract password
    PWORD$ = LTRIM$(PWORD$)
    PWORD$ = RTRIM$(PWORD$)

    D$ = MID$(B$, Y + 1)
    X = INSTR(D$, "{")
    Y = INSTR(D$, "}")
    IF X = 0 THEN RETURN
    IF Y < X + 1 THEN GOTO BADSOURCE

    SCRIPT$ = MID$(D$, X + 1, Y - X - 1)     ' extract script name
    SCRIPT$ = LTRIM$(SCRIPT$)
    SCRIPT$ = RTRIM$(SCRIPT$)

    SPEED$ = ""
    B$ = MID$(D$, Y + 1)
    X = INSTR(B$, "{")
    Y = INSTR(B$, "}")
    IF X = 0 THEN RETURN
    IF Y < X + 1 THEN GOTO BADSOURCE
    SPEED$ = MID$(B$, X + 1, Y - X - 1)
    X = INSTR(SPEED$, ",")
    IF X > 1 THEN SPEED$ = MID$(SPEED$, 1, X - 1)

    X = INSTR(L$, "{username,")
    IF X > 0 THEN
        Y = INSTR(X, L$, "}")
        USERNAME$ = MID$(L$, X + 10, Y - X - 10)
    END IF

    X = INSTR(L$, "{calls,")
    IF X > 0 THEN
        Z = X + 7
        Y = INSTR(X, L$, "}")
        NCALLS$ = MID$(L$, Z, Y - Z)
    ELSE
        IF LDATE$ = "00/00/00" THEN
            NCALLS$ = "0"
        ELSE NCALLS$ = "1"
        END IF
    END IF

    X = INSTR(L$, "{prefix,")
    IF X > 0 THEN
        Y = INSTR(X, L$, "}")
        prefix = VAL(MID$(L$, Y - 1, 1))
    END IF

    RETURN

BADSOURCE:
    CLS
    PRINT "Defective input file."
    CLOSE
    SYSTEM
    END

TRAPPER:
    PRINT "Input file " + F1$ + " not found."
    SYSTEM
    END



'   mTel phone directory entries.  Each field is preceded by one
'   character indicating number of used characters in following
'   field.  Five fields with their size characters gives a total of
'   197 characters per line.  The total directory size is always 100
'   entries (100 lines).  Changed to 200 entries in October 2002.
'
'   The directory file can be edited using one of the following
'   command lines:
'
'       e /b197 mtel.fon
'       edit /197 mtel.fon
'       tde -b197 mtel.fon
'
'     Entry = Record
'               Name        : String[60];
'               Number      : String[60];
'               Laston      : String[12];
'               Password    : String[30];
'               Login       : String[30];
'             End;
'

