
rem  Program to create a SyncTERM compatible lst file from short BBS text file.
rem  Free from David Rife 09-05-2008
rem  Added password choice 09-05-2008
rem  Improved stripping of leading and trailing spaces in name strings.
rem  09-06-2008 Added stripping of leading asterisk in BBS name.
rem  09-07-2008S Simplified some code.

    INPUT "What is the user name "; U$
    INPUT "Do you want passwords (y/N) "; Y$

    F$ = "SHORT.TXT"
    G$ = "SYNCTRM.LST"

    ON ERROR GOTO TRAPPER

    OPEN F$ FOR INPUT AS #1
    OPEN G$ FOR OUTPUT AS #2


    PRINT #2, CHR$(9) + "Port           =23"
    PRINT #2, CHR$(9) + "ConnectionType =Telnet"
    PRINT #2, CHR$(9) + "DownloadPath   ="
    PRINT #2, CHR$(9) + "UploadPath     ="
    PRINT #2, CHR$(9) + "Password       ="
    PRINT #2, CHR$(9) + "ScreenMode     =80x25"
    PRINT #2, CHR$(9) + "NoStatus       =true"
    PRINT #2, CHR$(9) + "ANSIMusic      =1"
    PRINT #2, CHR$(9) + "Font           =Codepage 437 English"
    IF U$ <> "" THEN PRINT #2, CHR$(9) + "UserName       =" + U$


rem  Find line that contains "* = NEW"
    x = 0
    WHILE x = 0
        LINE INPUT #1, L$
        x = INSTR(L$, "* = NEW")
    WEND

rem  Discard next three lines
    LINE INPUT #1, L$
    LINE INPUT #1, L$
    LINE INPUT #1, L$

ONELINE:
    LINE INPUT #1, L$
    IF INSTR(L$, "-------") > 0 GOTO ALLDONE
    N$ = MID$(L$, 1, 44)

rem  Strip leading asterisk from N$
    IF MID$(N$, 1, 1) = "*" THEN N$ = MID$(N$, 2, LEN(N$) )

rem  Strip leading spaces from N$
    WHILE MID$(N$, 1, 1 ) = " "
        N$ = MID$(N$, 2)
    WEND

rem  Strip end spaces from N$
    WHILE MID$(N$, LEN(N$)) = " "
        N$ = MID$(N$, 1, LEN(N$) - 1)
    WEND

    A$ = MID$(L$, 45)
    PRINT #2, " "
    PRINT #2, "[" + N$ + "]"
    PRINT #2, CHR$(9) + "Address        =" + A$
    PRINT #2, CHR$(9) + "NoStatus       =true"
    PRINT #2, CHR$(9) + "Port           =23"
    PRINT #2, CHR$(9) + "ConnectionType =Telnet"
    IF U$ <> "" THEN PRINT #2, CHR$(9) + "UserName       =" + U$

    IF UCASE$(Y$) <> "Y" THEN GOTO ONELINE

rem  Generate random password
    RANDOMIZE TIMER
    N = 8
    P$ = CHR$(INT(26 * RND(1) + 97))
    FOR i = 1 TO N - 1
        IF x = 1 THEN
            r = INT(36 * RND(1) + 97)
        ELSE
            r = INT(26 * RND(1) + 97)
        END IF
        IF r > 122 THEN r = r - 75
        P$ = P$ + CHR$(r)
    NEXT i

    PRINT #2, CHR$(9) + "Password       =" + P$
    GOTO ONELINE

ALLDONE:
    PRINT #2, " "
    CLOSE
    PRINT G$ + " has been created from " + F$ + "."
    SYSTEM
    END

TRAPPER:
    PRINT "Input file " + F$ + " not found."
    SYSTEM
    END

